#version 150

uniform samplerCube tex0;

in FragmentData {
	vec3 cubeCenter;
	vec3 cubeNormal;
	vec3 viewPos;
} frag;

out vec4 frag_color;

void main() {
	float sideDist[6];
	frag_color.r = distance(frag.viewPos, frag.cubeCenter)/length(frag.cubeNormal) - 1;
	vec3 ray = normalize(frag.viewPos);
	frag_color = texture(tex0, sin(frag.viewPos*.1));
	vec3 cN = normalize(frag.cubeNormal);
	float cubeProj = dot(ray, cN);
	float scale = 2 * length(frag.cubeNormal) / cubeProj;
	vec3 touchBack = scale*ray + frag.viewPos;
	vec3 cubeCoord = touchBack-frag.cubeCenter;

	// https://stackoverflow.com/questions/23166898/efficient-way-to-calculate-a-3x3-rotation-matrix-from-the-rotation-defined-by-tw
	vec3 v2 = vec3(0, 1, 0);
	vec3 v1 = cN;

    mat3 m1, m2;

    vec3 axis = cross(v1, v2);
    axis = normalize(axis);

    m1[0] = v1;
    m2[0] = v2;

    m1[1] = axis;
    m2[1] = axis;

    m1[2] = cross(m1[1], m1[0]);
    m2[2] = cross(m2[1], m2[0]);

    m1 = transpose(m1);

	mat3 matrix = m2 * m1;
    	
	cubeCoord = matrix * cubeCoord;
	frag_color = texture(tex0, cubeCoord);	
}
