#version 150

#pragma tdm_include "tdm_transform.glsl"

layout(triangles) in;
layout(triangle_strip, max_vertices = 18) out;

//in vec3 var_worldPos[];

out FragmentData {
	vec3 cubeCenter;
	vec3 cubeNormal;
	vec3 viewPos;
} frag;

void main() {
    vec3 v0 = gl_in[0].gl_Position.xyz;
    vec3 v1 = gl_in[1].gl_Position.xyz;
    vec3 v2 = gl_in[2].gl_Position.xyz;
	vec3 n = cross(v1-v2,v2-v0);
	n /= sqrt(length(n));
	
	vec3 center = distance(v2,v1)>distance(v1,v0) ? (v2+v1)/2 : (v0+v1)/2;
	center += n/2;
    frag.cubeCenter = center;
    frag.cubeNormal = n/2;
    
	gl_Position = u_projectionMatrix * vec4(v0, 1);
	frag.viewPos = v0;
	EmitVertex();
	gl_Position = u_projectionMatrix * vec4(v1, 1);
	frag.viewPos = v1;
	EmitVertex();
	gl_Position = u_projectionMatrix * vec4(v2, 1);
	frag.viewPos = v2;
	EmitVertex();
    EndPrimitive();	
}